#include "kk_log.h"

#include "klist.h"
#include "kk_product.h"
#include "com_api.h"
#include "kk_opcode.h"
#include "kk_lan_ctrl.h"
#include "kk_data_mng.h"
#include "cJSON.h"
#include "kk_ccu_msg.h"
#include "kk_oldccu_msg.h"
#include "kk_newccu_msg.h"



int find_match_pos(cJSON *array,const char *tag,const char *match)
{
	int i = 0;
	int pos = -1;
	cJSON *item;
	cJSON *mh;

	int size = cJSON_GetArraySize(array);
	for(;i<size;i++){
		item = cJSON_GetArrayItem(array,i);
		mh = cJSON_GetObjectItem(item,tag);
		if(strcmp(mh->valuestring,match)==0){
			pos = i;
			break;
		}
	}
	return pos;
}

int match_opcode_pos(cJSON *array,const char *opcode,int ch)
{
	int i = 0;
	int pos = -1;
	cJSON *item;
	cJSON *mh;
	cJSON *channel;
	
	int size = cJSON_GetArraySize(array);
	for(;i<size;i++){
		item = cJSON_GetArrayItem(array,i);
		mh = cJSON_GetObjectItem(item,"opcode");
		channel = cJSON_GetObjectItem(item,"channel");
		if((strcmp(mh->valuestring,opcode)==0) &&
			(atoi(channel->valuestring)==ch)){
			pos = i;
			break;
		}
	}
	return pos;
}


int match_value_string(cJSON *valueRange,const char *val)
{
	cJSON *item;
	int i = 0;
	int pos = -1;
	int size = cJSON_GetArraySize(valueRange);
	
	for(;i<size;i++){
		item = cJSON_GetArrayItem(valueRange,i);
		
		if(strcmp(item->valuestring,val)==0){
			pos = i;
			break;
		}
	}
	return pos;
}


cJSON * ctrl_conver(kk_map_dev_node_t *devNode,int nodeId,cJSON *arg,cJSON *opcode)
{
	cJSON *params = cJSON_CreateObject();
	cJSON *val;

	cJSON *newccuItem;
	cJSON *oldccuItem;

	cJSON *o_dataType;
	cJSON *n_dataType;

	cJSON *n_valueRange;
	cJSON *o_valueRange;

	cJSON *n_identifier;

	int pos;
	int channel;
	char ch[33];
	
	printf("[%s][%d]\n",__FUNCTION__,__LINE__);

	kk_lan_db_channel_get(nodeId,&channel);
	
	snprintf(ch,33,"%d",channel);
	printf("nodeId=%d,channel=%d,ch=%s\n",nodeId,channel,ch);
	
	pos = match_opcode_pos(devNode->oldccu,opcode->valuestring,channel);
	printf("[opcode->valuestring]%s\n",opcode->valuestring);
	printf("[match pos]%d\n",pos);
	
	if(pos==-1){
		return NULL;
	}
	
	newccuItem = cJSON_GetArrayItem(devNode->newccu,pos);
	oldccuItem = cJSON_GetArrayItem(devNode->oldccu,pos);

	o_dataType = cJSON_GetObjectItem(oldccuItem,"dataType");
	o_valueRange = cJSON_GetObjectItem(oldccuItem,"valueRange");
	
	n_dataType = cJSON_GetObjectItem(newccuItem,"dataType");
	n_valueRange = cJSON_GetObjectItem(newccuItem,"valueRange");
	n_identifier =  cJSON_GetObjectItem(newccuItem,"identifier");



	printf("1111\n");
	if(strcmp(o_dataType->valuestring,"map")==0){
		printf("2222\n");
		val = map_type_convert(o_dataType,o_valueRange,arg,n_valueRange);
	}else{
		printf("3333\n");
		val = msg_convert_value(o_dataType,n_dataType,arg);
	}
	printf("4444-->%d\n",val->type);
		if(val->type==cJSON_False){
			cJSON_AddFalseToObject(params,n_identifier->valuestring);
		}else if(val->type==cJSON_True){
			cJSON_AddTrueToObject(params,n_identifier->valuestring);
		}else if(val->type==cJSON_NULL){
			cJSON_AddNullToObject(params,n_identifier->valuestring);
		}else if(val->type==cJSON_Number){
			cJSON_AddNumberToObject(params,n_identifier->valuestring,val->valuedouble);
		}else if(val->type==cJSON_String){
			cJSON_AddStringToObject(params,n_identifier->valuestring,val->valuestring);
		}else if(val->type==cJSON_Array){
			printf("......................\n");
		}
	

	return params;
}

typedef int(*match_func)(cJSON *);

typedef struct
{
	char *Opcode;
	match_func func;
}MATCH_ITEM_S;

int opcode_switch(cJSON *root);

static MATCH_ITEM_S match_table[] = {
	{SWITCH_OPCODE,opcode_switch}
};

MATCH_ITEM_S *get_match_table(void)
{
	return &match_table;
}

int kk_ccu_opcode_handle(cJSON *root)
{
	int i;
	//int size = sizeof(match_table)/sizeof(MATCH_ITEM_S);
	cJSON *opcode = cJSON_GetObjectItem(root,OPCODE_STR);
	//MATCH_ITEM_S *pMh = get_match_table();
	
	printf("[%s][%d]\n",__FUNCTION__,__LINE__);

	if(opcode==NULL||opcode->type!=cJSON_String){
		return -1;
	}
	
	/*for(i=0;i<size;i++,pMh++) {
		if(strcmp(opcode->valuestring,pMh->Opcode)==0){
			if(pMh->func){
				printf("[%s][%d]match table[%d]\n",__FUNCTION__,__LINE__,i);
				pMh->func(root);
			}
		}
	}*/
	opcode_switch(root);
}

//向midware发送数据
int kk_ipc_send_json(cJSON *root)
{
	char *msg;

	if(root==NULL){
		return -1;
	}
	
	msg=cJSON_Print(root);
	printf("[lan->midware]json:\n%s\n",msg);
	cJSON_Minify(msg);
	kk_ipc_send(IPC_APP2MID, msg, strlen(msg)+1);
	free(msg);
	
	return 0;
}


int opcode_switch(cJSON *root)
{
	cJSON *msg;

	cJSON *nodeId;
	cJSON *opcode;
	cJSON *arg;
	cJSON *requester;
	char deviceCode[33]={0};

	kk_map_dev_node_t *dev;
	
	printf("[%s][%d]\n",__FUNCTION__,__LINE__);
	nodeId = cJSON_GetObjectItem(root,NODEID_STR);
	opcode = cJSON_GetObjectItem(root,OPCODE_STR);
	arg = cJSON_GetObjectItem(root,ARG_STR);
	requester= cJSON_GetObjectItem(root,REQUEST_STR);

	if(nodeId==NULL||opcode==NULL||arg==NULL ){
		printf("[%s][%d]\n",__FUNCTION__,__LINE__);
		return;
	}
	
	if((requester!=NULL) &&(strcmp(requester->valuestring,HJ_SERVER)!=0)){
		WARNING_PRINT("[%s] err,%s,%s\n",REQUEST_STR,HJ_SERVER,requester->valuestring);
	}


	kk_lan_db_deviceCode_get(atoi(nodeId->valuestring),deviceCode);

	if(kk_map_dev_search_by_deviceCode(deviceCode, &dev)==0){
		printf("[%s][%d]\n",__FUNCTION__,__LINE__);
		cJSON *params=ctrl_conver(dev,atoi(nodeId->valuestring),arg,opcode);
	
		msg=property_set(dev->productCode,dev->deviceCode,"*","*",params);
		kk_ipc_send_json(msg);
	
		
	}else{
		printf("[%s][%d]\n",__FUNCTION__,__LINE__);
	}
}









char *node_string(int nodeId)
{
	char *node = (char *)malloc(33);
	memset(node,0,33);
	
	snprintf(node,32,"%d",nodeId);
	return node;
}

char *double_string(double dVal,int size)
{
	char *buff = (char *)malloc(size+1);
	memset(buff,0,size+1);
	
	snprintf(buff,size,"%6f",dVal);
	return buff;
}





int update_device_status_2_oldccu(int nodeId,const char *opcode,const char *arg)
{
	cJSON *msg;
	char *nodeStr;

	if(arg==NULL){
		return -1;
	}
	printf("[%s][%d]nodeId=%d,status=%s\n",__FUNCTION__,__LINE__,nodeId,arg);

	if((nodeStr=node_string(nodeId))!=NULL){
		msg = old_ccu_msg_build(nodeStr,opcode,"success",arg);
		send_msg_to_module(msg);
		cJSON_Delete(msg);
		free(nodeStr);
		return 0;
	}

	return -1;
}



























